#!/usr/local/bin/perl

use CGI;
$query = new CGI;

$topic_directory = "topics";

if ($query->param('topic')) {
    $topic = $query->param('topic');
    &file_error unless (&open_topic);
    &format_error unless (&parse_topic);
    &print_page_start;
    &print_topic;
    &print_response_form;
    print "<P>Return to the <A HREF=\"display.pl\">topic list</A>.</P>\n";
    &print_page_end;
}
else {
    $page_title = "Topic Index";
    &print_page_start;
    &print_topic_index;
    &print_page_end;
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n</HEAD>\n";
    print "<BODY>\n<H1>$page_title</H1>\n";
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

sub print_topic_index {
    eval {
	opendir (TOPICS, "$topic_directory")
	    or die "Can't open $topic_directory";
	@topics = grep (/^.+\.txt$/, readdir (TOPICS));
	foreach $topic (@topics) {
	    $topic =~ s/(.+)\.txt/$1/;
	    &open_topic;
	    &parse_topic;
	    print "<A HREF=\"display.pl?topic=$topic\">";
	    print "$page_title</A>, $topic_author<BR>\n";		
	}
    };
}

sub open_topic {
    $topic_file = "$topic_directory/" . $topic . ".txt";
    eval {
	open (TOPIC, "< $topic_file") 
	    or die "Can't open $topic_file";
	@topic_text = <TOPIC>;
    };
    if ($@) {
	$error = $@;
	return undef;
    }
    else {
	return 1;
    }
}

sub parse_topic {
    $topic_text = join '', @topic_text;
    # Extract the topic title from the topic
    if ($topic_text =~ /<title>(.*)<\/title>/s) {
	$page_title = $1;
    }
    else {
	$err = "title";
	return undef;
    }

    # Extract the author from the topic
    if ($topic_text =~ /<author>(.*)<\/author>/s) {
	$topic_author = $1;
    }
    else {
	$err = "author";
	return undef;
    }

    # Extract the date when the file was last modified
    if ($topic_text =~ /<last_modified>(.*)<\/last_modified>/s) {
	$last_modified = $1;
    }
    else {
	$err = "lastmod";
	return undef;
    }
    
    # Extract the first post from the topic
    if ($topic_text =~ /<post>(.*)<\/post>/s) {
	$post = $1;
    }
    else {
	$err = "post";
	return undef;
    }

    @response_list = ();
    while ($topic_text =~ /<response>(.*?)<\/response>/sg) {
	$response = $1;
	if ($response =~ /<response_author>(.*)<\/response_author>/s) {
	    push @response_list, $1;
	}
	else {
	    $err = "response author";
	    return undef;
	}
	if ($response =~ /<response_body>(.*)<\/response_body>/s) {
	    push @response_list, $1;
	}
	else {
	    $err = "response body";
	    return undef;
	}
    }

    # Return a value so that the parse was considered successful.
    1;
}

sub print_topic {
    print "<P>Author: $topic_author</P>\n";
    print "<P>Most recent response: ";
    print scalar localtime($last_modified), "</P>\n";
    print "<P>$post</P>\n";
    print "<HR>\n";
    $part_type = "author";
    foreach $response_part (@response_list) {
	if ($part_type eq "author") {
	    print "<P>Author: $response_part</P>\n";
	    $part_type = "body";
	}
	else {
	    print "<P>$response_part</P>\n";
	    print "<HR>\n";
	    $part_type = "author";
	}
    }
}

sub print_response_form {
    print "<FORM METHOD=\"post\" ACTION=\"post.pl\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"response\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"response_to\" ";
    print "VALUE=\"$topic\">\n";
    print "Author: ";
    print "<INPUT TYPE=\"text\" NAME=\"author\" ";
    print "SIZE=40 MAXLENGHT=72 VALUE=\"$author\"><BR>\n";
    print "Message body: <BR>\n";
    print "<TEXTAREA ROWS=10 COLS=60 NAME=\"post\" WRAP=\"virtual\">";
    print "</TEXTAREA><BR>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"post topic\"><BR>\n";
    print "</FORM>\n";
}

sub format_error {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>Format Error</TITLE>\n</HEAD>\n";
    print "<BODY><H3>Format Error</H3>\n<P>$err</P>\n</BODY>\n</HTML>\n";
    exit;
}

sub file_error {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>File Error</TITLE>\n</HEAD>\n";
    print "<BODY><H3>File Error</H3>\n<P>$error</P>\n</BODY>\n</HTML>\n";
    exit;
}


