#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw( fatalsToBrowser );

$cart_file = "cart.txt";
$catalog_file = "products.txt";
$query = new CGI;

if ($query->cookie('session_id')) {
    $session_id = ($query->cookie('session_id'));
}

if ($query->param('action')) {
    if ($query->param('action') eq 'remove') {
	$page_title = "Shopping Cart";
	&remove_item;
	&print_page_start;
	&get_cart_contents;
	if (@user_cart) {
	    &get_product_list;
	    &print_cart;
	}
	else {
	    &print_no_cart;
	}
	&print_page_end;
    }
}
else {
    $page_title = "Shopping Cart";
    &print_page_start;
    &get_cart_contents;
    if (@user_cart) {
	&get_product_list;
	&print_cart;
    }
    else {
	&print_no_cart;
    }
    &print_page_end;
}

sub remove_item {
    open (CART, "+>> $cart_file") 
	or die "Can't open cart file";
    flock CART, 2;
    seek CART, 0, 0;
    @records = <CART>;
    @new_records = ();
    foreach $record (@records) {
	chomp $record;
	($rec_session_id, $rec_product_id, $rec_quantity) =
	    split /\t/, $record;
	unless (($rec_session_id eq $session_id) and
		($rec_product_id eq $query->param('product_id'))) {
	    push @new_records, $record . "\n";
	}
    }
    seek CART, 0, 0;
    truncate CART, 0;
    print CART @new_records;
    close CART;
}

sub get_cart_contents {
    open (CART, "< $cart_file") 
	or die "Can't open shopping cart file";
    @records = <CART>;
    @user_cart = ();
    foreach $record (@records) {
	chomp $record;
	($rec_session_id, $rec_product_id, $rec_quantity) =
	    split /\t/, $record;
	if ($rec_session_id eq $session_id) {
	    push @user_cart, $record;
	}
    }
}

sub get_product_list {
    open (CATALOG, "< $catalog_file")
	or die "Can't open catalog file";
    %product_names = ();
    %product_prices = ();
    while (<CATALOG>) {
	($cat_product_id, $product_name, $product_price) =
	    split /\t/;
	$product_names{$cat_product_id} = $product_name;
	$product_prices{$cat_product_id} = $product_price;
    }
    close CATALOG;
}

sub print_cart {
    print "<CENTER>\n<TABLE>\n<TR>\n";
    print "<TH>Product ID</TH>\n<TH>Product Name</TH>\n";
    print "<TH>Price</TH>\n<TH>Quantity</TH>\n</TR>\n";
    foreach $cart_item (@user_cart) {
	($rec_session_id, $rec_product_id, $rec_quantity) =
	    split /\t/, $cart_item;
	print "<TD>$rec_product_id</TD>\n";
	print "<TD>", $product_names{$rec_product_id}, "</TD>\n";
	print "<TD>", $product_prices{$rec_product_id}, "</TD>\n";
	print "<TD>$rec_quantity</TD>\n";
	print "<TD>\n<FORM>\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"remove\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"product_id\" ";
	print "VALUE=\"$rec_product_id\">\n";
	print "<INPUT TYPE=\"submit\" VALUE=\"remove\">\n";
	print "</TD>\n";
	print "</TR>\n";
    }
    print "</TABLE>\n";
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1 ALIGN=\"center\">$page_title</H1>\n";
}

sub print_no_cart {
    print "<P>There are no items in your shopping cart.</P>\n";
}

sub print_page_end {
    print "<P><CENTER><B>";
    print "<A HREF=\"catalog.pl\">return to catalog</A></B></CENTER></P>\n";
    print "<p><center><b>";
    print "<a href=\"checkout.pl\">check out</a></b></center></p>\n";
    print "</BODY>\n</HTML>\n";
}


