#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$query = new CGI;

$topic_directory = "topics";

if ($query->param('action')) {
    &set_variables;

    # The form to create a new topic has been submitted
    if ($action eq "new") {
	if (&valid_form) {
	    &write_new_topic;
	    $page_title = $title;
	    &print_page_start;
	    &print_success;
	    &print_page_end;
	}
	else {
	    $page_title = "New Topic";
	    &print_page_start;
	    &print_error;
	    &print_form;
            &print_page_end;
	}
    }
    elsif ($action = "response") {
	&set_variables;
	if (&valid_form) {
	    &write_response;
	    $page_title = "New response entered";
	    &print_page_start;
	    &print_response_success;
	    &print_page_end;
	}
	else {
	    $page_title = "New response";
	    &print_page_start;
	    &print_error;
	    &print_form;
	    &print_page_end;
	}
    }
}
else {
    $action = "new";
    $page_title = "Enter new topic";
    &print_page_start;
    $topic_type = "new";
    &print_form;
    &print_page_end;
}

sub set_variables {
    $action = $query->param('action');
    $title = $query->param('title');
    $author = $query->param('author');
    $post = $query->param('post');
    $response_to = $query->param('response_to');
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n</HEAD>\n";
    print "<BODY>\n<H1>$page_title</H1>\n";
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

sub print_form {
    print "<FORM METHOD=\"post\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"$action\">\n";
    if ($action eq "response") {
	print "<INPUT TYPE=\"hidden\" NAME=\"response_to\" ";
	print "VALUE=\"$response_to\">\n";
    }
    if ($action eq "new") {
	print "Topic: ";
	print "<INPUT TYPE=\"text\" NAME=\"title\" ";
	print "SIZE=40 MAXLENGTH=72 VALUE=\"$title\"><BR>\n";
    }
    print "Author: ";
    print "<INPUT TYPE=\"text\" NAME=\"author\" ";
    print "SIZE=40 MAXLENGHT=72 VALUE=\"$author\"><BR>\n";
    print "Message body: <BR>\n";
    print "<TEXTAREA ROWS=10 COLS=60 NAME=\"post\" WRAP=\"virtual\">";
    print "$post</TEXTAREA><BR>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"post topic\"><BR>\n";
    print "</FORM>\n";
}

sub valid_form {
    $error_message = '';
    if ($title eq '' && $action eq 'new') {
	$error_message .= "You must enter a title.<BR>\n";
    }
    if ($author eq '') {
	$error_message .= "You must enter an author.<BR>\n";
    }
    if ($post eq '') {
	$error_message .= "You must enter a message.<BR>\n";
    }
    if ($error_message eq '') {
	return 1;
    }
    else {
	return undef;
    }
}

sub write_new_topic {
    $topic_file = time . $$ . '.txt';
    open (TOPIC, "> $topic_directory/$topic_file")
	or die "Can't open $topic_directory/$topic_file";
    print TOPIC "<title>$title</title>\n";
    print TOPIC "<author>$author</author>\n";
    print TOPIC "<last_modified>" . time . "</last_modified>\n";
    print TOPIC "<post>\n";
    $post =~ s/\n/<BR>\n/g;
    print TOPIC $post;
    print TOPIC "</post>\n";
    close TOPIC;
}

sub write_response {
    $topic_file = $response_to . '.txt';
    open (TOPIC, "+>> $topic_directory/$topic_file")
	or die "Can't open $topic_directory/$topic_file";
    flock TOPIC, 2;
    seek TOPIC, 0, 0;
    my @topic_text = <TOPIC>;
    my $topic_text = join '', @topic_text;
    my $current_time = time;
    $topic_text =~ s/<last_modified>(\d+)<\/last_modified>/<last_modified>$current_time<\/last_modified>/;
    seek TOPIC, 0, 0;
    truncate TOPIC, 0;
    print TOPIC $topic_text;
    print TOPIC "<response>\n";
    print TOPIC "<response_author>$author</response_author>\n";
    $post =~ s/\n/<BR>\n/g;
    print TOPIC "<response_body>$post</response_body>\n";
    print TOPIC "</response>\n";
    close TOPIC;
}

sub print_success {
    "<P>New topic created.</P>\n";
}

sub print_response_success {
    print "<P>New response entered.</P>\n";
}

sub print_error {
    print "<FONT COLOR=#CC0000>\n";
    print "<P>Please correct the following errors:<BR>\n";
    print "$error_message\n</FONT></P>\n";
}




