#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$query = new CGI;

$news_directory = "news";

if ($query->param('action')) {
    &set_variables;

    # The form to create a new topic has been submitted
    if ($action eq "new") {
        if (&valid_form) {
            &write_new_topic;
            $page_title = $title;
            &print_page_start;
            &print_success;
            &print_page_end;
        }
        else {
            $page_title = "New Topic";
            &print_page_start;
            &print_error;
            &print_form;
            &print_page_end;
        }
    }
}
else {
    $action = "new";
    $page_title = "Enter new topic";
    &print_page_start;
    &print_form;
    &print_page_end;
}

sub set_variables {
    $action = $query->param('action');
    $title = $query->param('title');
    $byline = $query->param('byline');
    $body = $query->param('body');
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n</HEAD>\n";
    print "<BODY>\n<H1>$page_title</H1>\n";
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

sub print_form {
    print "<FORM METHOD=\"post\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"$action\">\n";
    if ($action eq "new") {
        print "Headline: ";
        print "<INPUT TYPE=\"text\" NAME=\"title\" ";
        print "SIZE=40 MAXLENGTH=72 VALUE=\"$title\"><BR>\n";
    }
    print "Byline: ";
    print "<INPUT TYPE=\"text\" NAME=\"byline\" ";
    print "SIZE=40 MAXLENGHT=72 VALUE=\"$byline\"><BR>\n";
    print "Story: <BR>\n";
    print "<TEXTAREA ROWS=10 COLS=60 NAME=\"body\" WRAP=\"virtual\">";
    print "$body</TEXTAREA><BR>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"publish story\"><BR>\n";
    print "</FORM>\n";
}

sub valid_form {
    $error_message = '';
    if ($title eq '' && $action eq 'new') {
        $error_message .= "You must enter a story title.<BR>\n";
    }
    if ($byline eq '') {
        $error_message .= "You must enter a byline.<BR>\n";
    }
    if ($body eq '') {
        $error_message .= "You must enter the body of your story.<BR>\n";
    }
    if ($error_message eq '') {
        return 1;
    }
    else {
        return undef;
    }
}

sub write_new_topic {
    $news_file = time . $$ . '.txt';
    open (STORY, "> $news_directory/$news_file")
        or die "Can't open $news_directory/$news_file";
    print STORY "<DATE_FILED>" . scalar(localtime(time)) . "</DATE_FIELD>\n";
    print STORY "<STORY_TITLE>$title</STORY_TITLE>\n";
    print STORY "<BYLINE>$byline</BYLINE>\n";
    print STORY "<BODY>\n";
    $body =~ s/\n/<BR>\n/g;
    print STORY $body;
    print STORY "</BODY>\n";
    close STORY;
}

sub print_success {
    "<P>New story published.</P>\n";
}

sub print_error {
    print "<FONT COLOR=#CC0000>\n";
    print "<P>Please correct the following errors:<BR>\n";
    print "$error_message\n</FONT></P>\n";
}
