#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$query = new CGI;

$news_directory = "news";

if ($query->param('story') && $query->param('template')) {
    $story = $query->param('story');
    $template = $query->param('template');
    &file_error unless (&open_story);
    &format_error unless (&parse_story);
    &file_error unless (&open_template);
    &format_error unless (&parse_template);
    &print_page_start;
    &print_story;
    print "<P>Return to the <A HREF=\"display.pl\">story list</A>.</P>\n";
    &print_page_end;
}
else {
    $page_title = "Story Index";
    &print_page_start;
    &print_story_index;
    &print_page_end;
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n</HEAD>\n";
    print "<BODY>\n<H1>$page_title</H1>\n";
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

sub print_story_index {
    eval {
	opendir (STORIES, "$news_directory")
	    or die "Can't open $story_directory";
	@stories = grep (/^.+\.txt$/, readdir (STORIES));
	foreach $story (@stories) {
	    $story =~ s/(.+)\.txt/$1/;
	    &open_story;
	    &parse_story;
	   
	    # In this case, we assume that stories contain
	    # a value called STORY_TITLE.
	    if ($vals{'STORY_TITLE'}) {
		print "<A HREF=\"story.pl?story=$story&template=story\">";
		print $vals{'STORY_TITLE'}, "</A><BR>\n";	     
	    }
	}
    };
}

sub open_template {
    $template_file = $template . ".tmpl";
    eval {
	open (TEMPLATE, "< $template_file") 
	    or die "Can't open $template_file";
	@template_text = <TEMPLATE>;
    };
    if ($@) {
	$error = $@;
	return undef;
    }
    else {
	return 1;
    }
}

sub open_story {
    $story_file = "$news_directory/" . $story . ".txt";
    eval {
	open (STORY, "< $story_file") 
	    or die "Can't open $story_file";
	@story_text = <STORY>;
    };
    if ($@) {
	$error = $@;
	return undef;
    }
    else {
	return 1;
    }
}

sub parse_template {
    $template_text = join '', @template_text;

    $template_text =~ s/\#(.+?)\#/$vals{$1}/sg;

    # Return a value so that the parse was considered successful.
    1;
}

sub parse_story {
    $story_text = join '', @story_text;

    %vals = ();
    while ($story_text =~ /<(.+?)>(.+?)<\/.+?/sg) {
	$vals{$1} = $2;
    }

    # Return a value so that the parse was considered successful.
    1;
}

sub print_story {
    print $template_text;
}

sub format_error {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>Format Error</TITLE>\n</HEAD>\n";
    print "<BODY><H3>Format Error</H3>\n<P>$err</P>\n</BODY>\n</HTML>\n";
    exit;
}

sub file_error {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>File Error</TITLE>\n</HEAD>\n";
    print "<BODY><H3>File Error</H3>\n<P>$error</P>\n</BODY>\n</HTML>\n";
    exit;
}























