#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;

$query = new CGI;

$database = "rafeco_rc3";
$db_server = "db4.pair.com";
$user = "rafeco_w";
$password = "vmppa55r";

%cc_types = ('AMEX' => 'American Express',
	     'VISA' => 'Visa',
	     'MC' => 'Mastercard',
	     'DISC' => 'Discover');

if ($query->cookie('session_id')) {
    $session_id = $query->cookie('session_id');
}
else {
    $page_title = "Checkout: Error";
    &print_page_start;
    &print_no_cart;
    &print_page_end;
    exit;
}

&db_connect;

&get_cart_contents;

if ($cart_query->rows) {
    if ($query->param('cc_type')) {
	&set_variables;
	if (! &valid_form) {
	    $page_title = "Checkout Complete";
	    &print_page_start;
	    &insert_order;
	    &empty_cart;
	    &print_success;
	    &print_page_end;
	}
	else {
	    $page_title = "Checkout: Please correct errors";
	    &print_page_start;
	    &print_error;
	    &print_form;
	    &print_page_end;
	}
    }
    else {
	$page_title = "Checkout";
	&print_page_start;
	&print_form;
	&print_page_end;
    }
}
else {
    $page_title = "Error: Your cart is empty";
    &print_page_start;
    &print_no_cart;
    &print_page_end;
}

&db_cleanup;

sub db_connect {
    $dbh = DBI->connect("DBI:mysql:$database:$db_server", $user, $password);
}

sub db_cleanup {
    if ($sth) {
	$rc = $sth->finish;
    }
    if ($cart_query) {
	$rc = $cart_query->finish;
    }
    $rc = $dbh->disconnect;
}

sub get_cart_contents {
    $statement = qq[
		    select product_id, quantity
		    from cart
		    where session_id = '$session_id'
		    ];
    $cart_query = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $cart_query->errstr, "\n";
    $rv = $cart_query->execute
	or die "Couldn't execute select statement: ", 
	$cart_query->errstr, "\n";
}

sub insert_order {
    # Create a unique Order ID
    $order_id = time . $$;

    # Insert all of the items in the user's cart into the 
    # order_products table

    while (@row = $cart_query->fetchrow_array) {
	($product_id, $quantity) = @row;
	$statement = qq[
			insert into order_products
			values ('$order_id', $product_id, $quantity)
			];
	$sth = $dbh->prepare($statement)
	    or die "Couldn't prepare the query:", $sth->errstr, "\n";
	$rv = $sth->execute
	    or die "Couldn't execute insert statement: ", 
	    $sth->errstr, "\n";	
    }
    
    # Create a record for the order itself
    $statement = qq[
		    insert into orders
		    values ('$order_id', '$name', '$address',
			    '$city', '$state', '$zip', 
			    '$cc_number', '$cc_type', 
			    '$exp_month', '$exp_year')
		    ];
    $insert = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $insert->errstr, "\n";
    $rv = $insert->execute
	or die "Order insert failed: ", 
	$insert->errstr, "\n";	
}

sub empty_cart {
    $statement = qq[
		    delete from cart 
		    where session_id = $session_id
		    ];
    $sth = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $sth->errstr, "\n";
    $rv = $sth->execute
	or die "Couldn't execute delete statement: ", $sth->errstr, "\n";
}

sub print_empty_cart {
    print "<P>You cannot check out until you have placed items ";
    print "in your shopping cart.</P>\n";
    print "<P>Return to the <A HREF=\"catalog.pl\">catalog</A>.</P>\n";
}

sub set_variables {
    $name = $query->param('name');
    $address = $query->param('address');
    $city = $query->param('city');
    $state = $query->param('state');
    $zip = $query->param('zip');
    $cc_type = $query->param('cc_type');
    $cc_number = $query->param('cc_number');
    $exp_month = $query->param('exp_month');
    $exp_year = $query->param('exp_year');
}

sub valid_form {
    $error_message = '';
    $error_message .= "<LI>You must enter your name\n" 
	if ($name =~ /^\s*$/);
    $error_message .= "<LI>You must enter your address\n"
	if ($address =~ /^\s*$/);
    $error_message .= "<LI>You must enter your city\n"
	if ($city =~ /^\s*$/);
    $error_message .= "<LI>You must enter a valid zip code\n"
	if ($zip !~ /^\d+$/);
    $error_message .= "<LI>You must enter a valid month of expiration\n"
	if ($exp_month > 12 || $exp_month < 1);
    $error_message .= "<LI>You must enter a valid year of expiration\n"
	if ($exp_year < 2000 || $exp_year > 2010);
    $error_message .= "<LI>You must enter a valid credit card number\n"
	if ($cc_number !~ /^\d+$/);
    return $error_message;
}

sub print_error {
    print "<P>Please correct the following errors:</P>\n";
    if ($error_message) {
	print "<UL>\n$error_message\n</UL>\n";
    }
}

sub print_form {
    print "<FORM>\n";
    print "<TABLE BORDER=0>\n";
    print "<TR><TD>Name:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"name\" VALUE=\"$name\">\n";
    print "</TD></TR>\n";
    print "<TR><TD>Street address:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"address\" ";
    print "VALUE=\"$address\" SIZE=40 MAXLENGTH=80></TD></TR>\n";
    print "<TR><TD>City:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"city\" ";
    print "VALUE=\"$city\"></TD></TR>\n";
    print "<TR><TD>State:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"state\" ";
    print "VALUE=\"$state\" SIZE=2 MAXLENGTH=2></TD></TR>\n";
    print "<TR><TD>Zip</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"zip\" ";
    print "VALUE=\"$zip\" SIZE=5 MAXLENGTH=5></TD></TR>\n";
    print "<TD>Credit card:</TD>\n<TD>\n<SELECT NAME=\"cc_type\">\n";
    foreach $key (sort {$a <=> $b} keys %cc_types) {
	print "<OPTION VALUE=\"$key\">", $cc_types{$key}, "\n";
    }
    print "</SELECT>\n</TD>\n";
    print "<TR><TD>Credit card number:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"cc_number\" ";
    print "VALUE=\"$cc_number\"></TD></TR>\n";
    print "<TR><TD>Expiration date:</TD>\n";
    print "<TD><INPUT TYPE=\"text\" NAME=\"exp_month\" ";
    print "VALUE=\"$exp_month\" SIZE=2 MAXLENGTH=2>\n";
    print "<INPUT TYPE=\"text\" NAME=\"exp_year\" ";
    print "VALUE=\"$exp_year\" SIZE=2 MAXLENGTH=4>\n";
    print "<TR><TD></TD>\n";
    print "<TD><INPUT TYPE=\"submit\" VALUE=\"Complete Checkout\">";
    print "</TD></TR>\n";
    print "</TABLE>\n";
    print "</FORM>\n";
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1 ALIGN=\"center\">$page_title</H1>\n";
}

sub print_no_cart {
    print "<P>There are no items in your shopping cart.</P>\n";
}

sub print_success {
    print "<P>Your order is complete.</P>\n";
}

sub print_page_end {
    print "<P><CENTER><B>";
    print"<A HREF=\"catalog.pl\">return to catalog</A></B></CENTER></P>\n";
    print "</BODY>\n</HTML>\n";
}

