#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    $form_info = $ENV{'QUERY_STRING'};
}
else {
    $input_size = $ENV{'CONTENT_LENGTH'};
    read (STDIN, $form_info, $input_size);
}

@input_pairs = split (/[&;]/, $form_info);

%input = ();
foreach $pair (@input_pairs) {
    # Convert plusses to spaces
    $pair =~ s/\+/ /g;
    
    # Split the name and value pair 
    ($name, $value) = split (/=/, $pair);
    
    # Decode the URL encoded name and value
    $name =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    $value =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    
    # Copy the name and value into the hash
    $input{$name} = $value;
}

print "Content-type: text/html\n\n";

print "<HTML><HEAD><TITLE>Name and Value Pairs</TITLE></HEAD><BODY>\n";

foreach $key (keys %input) {
    print "<P>$key : $input{$key}</P>\n";
}

print "</BODY></HTML>\n";
